Index: src/includes/classes/Smarty/sysplugins/smarty_internal_data.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_data.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_data.php	(revision )
@@ -13,164 +13,135 @@
  *
  * @package    Smarty
  * @subpackage Template
+ *
+ * @method mixed getConfigVars(string $varName = null, bool $searchParents = true)
+ * @method mixed getStreamVariable(string $variable)
+ * @method Smarty_Internal_Data clearAssign(mixed $tpl_var)
+ * @method Smarty_Internal_Data clearAllAssign()
+ * @method Smarty_Internal_Data clearConfig(string $varName = null)
+ * @method Smarty_Internal_Data configLoad(string $config_file, mixed $sections = null, string $scope = 'local')
+ * @property int $scope
  */
 class Smarty_Internal_Data
 {
     /**
+     * This object type (Smarty = 1, template = 2, data = 4)
+     *
+     * @var int
+     */
+    public $_objType = 4;
+
+    /**
      * name of class used for templates
      *
      * @var string
      */
     public $template_class = 'Smarty_Internal_Template';
+
     /**
      * template variables
      *
-     * @var array
+     * @var Smarty_Variable[]
      */
     public $tpl_vars = array();
+
     /**
      * parent template (if any)
      *
-     * @var Smarty_Internal_Template
+     * @var Smarty|Smarty_Internal_Template|Smarty_Internal_Data
      */
     public $parent = null;
+
     /**
      * configuration settings
      *
-     * @var array
+     * @var string[]
      */
     public $config_vars = array();
 
     /**
+     * extension handler
+     *
+     * @var Smarty_Internal_Extension_Handler
+     */
+    public $ext = null;
+
+    /**
+     * Smarty_Internal_Data constructor.
+     *
+     * Install extension handler
+     */
+    public function __construct()
+    {
+        $this->ext = new Smarty_Internal_Extension_Handler();
+        $this->ext->objType = $this->_objType;
+    }
+
+    /**
      * assigns a Smarty variable
      *
      * @param  array|string $tpl_var the template variable name(s)
      * @param  mixed        $value   the value to assign
      * @param  boolean      $nocache if true any output of this variable will be not cached
      *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for
+     *                              chaining
      */
     public function assign($tpl_var, $value = null, $nocache = false)
     {
         if (is_array($tpl_var)) {
             foreach ($tpl_var as $_key => $_val) {
                 if ($_key != '') {
-                    $this->tpl_vars[$_key] = new Smarty_variable($_val, $nocache);
+                    $this->tpl_vars[$_key] = new Smarty_Variable($_val, $nocache);
+                    if ($this->_objType == 2 && $this->scope) {
+                        $this->ext->_updateScope->updateScope($this, $_key);
-                }
-            }
+                    }
+                }
+            }
         } else {
             if ($tpl_var != '') {
-                $this->tpl_vars[$tpl_var] = new Smarty_variable($value, $nocache);
+                $this->tpl_vars[$tpl_var] = new Smarty_Variable($value, $nocache);
+                if ($this->_objType == 2 && $this->scope) {
+                    $this->ext->_updateScope->updateScope($this, $tpl_var);
-            }
-        }
+                }
+            }
-
-        return $this;
-    }
+        }
-
-    /**
-     * assigns a global Smarty variable
-     *
-     * @param  string  $varname the global variable name
-     * @param  mixed   $value   the value to assign
-     * @param  boolean $nocache if true any output of this variable will be not cached
-     *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function assignGlobal($varname, $value = null, $nocache = false)
-    {
-        if ($varname != '') {
-            Smarty::$global_tpl_vars[$varname] = new Smarty_variable($value, $nocache);
-            $ptr = $this;
-            while ($ptr instanceof Smarty_Internal_Template) {
-                $ptr->tpl_vars[$varname] = clone Smarty::$global_tpl_vars[$varname];
-                $ptr = $ptr->parent;
-            }
-        }
-
         return $this;
     }
 
     /**
-     * assigns values to template variables by reference
+     * appends values to template variables
      *
-     * @param string   $tpl_var the template variable name
-     * @param          $value
-     * @param  boolean $nocache if true any output of this variable will be not cached
+     * @api  Smarty::append()
+     * @link http://www.smarty.net/docs/en/api.append.tpl
      *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @param  array|string $tpl_var                                           the template variable name(s)
+     * @param  mixed        $value                                             the value to append
+     * @param  bool         $merge                                             flag if array elements shall be merged
+     * @param  bool         $nocache                                           if true any output of this variable will
+     *                                                                         be not cached
+     *
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
      */
-    public function assignByRef($tpl_var, &$value, $nocache = false)
+    public function append($tpl_var, $value = null, $merge = false, $nocache = false)
     {
-        if ($tpl_var != '') {
-            $this->tpl_vars[$tpl_var] = new Smarty_variable(null, $nocache);
-            $this->tpl_vars[$tpl_var]->value = & $value;
+        return $this->ext->append->append($this, $tpl_var, $value, $merge, $nocache);
-        }
+    }
 
-        return $this;
-    }
-
     /**
-     * appends values to template variables
+     * assigns a global Smarty variable
      *
-     * @param  array|string $tpl_var the template variable name(s)
-     * @param  mixed        $value   the value to append
-     * @param  boolean      $merge   flag if array elements shall be merged
+     * @param  string  $varName the global variable name
+     * @param  mixed   $value   the value to assign
-     * @param  boolean      $nocache if true any output of this variable will be not cached
+     * @param  boolean $nocache if true any output of this variable will be not cached
      *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
      */
-    public function append($tpl_var, $value = null, $merge = false, $nocache = false)
+    public function assignGlobal($varName, $value = null, $nocache = false)
     {
-        if (is_array($tpl_var)) {
-            // $tpl_var is an array, ignore $value
-            foreach ($tpl_var as $_key => $_val) {
-                if ($_key != '') {
-                    if (!isset($this->tpl_vars[$_key])) {
-                        $tpl_var_inst = $this->getVariable($_key, null, true, false);
-                        if ($tpl_var_inst instanceof Undefined_Smarty_Variable) {
-                            $this->tpl_vars[$_key] = new Smarty_variable(null, $nocache);
-                        } else {
-                            $this->tpl_vars[$_key] = clone $tpl_var_inst;
+        return $this->ext->assignGlobal->assignGlobal($this, $varName, $value, $nocache);
-                        }
+    }
-                    }
-                    if (!(is_array($this->tpl_vars[$_key]->value) || $this->tpl_vars[$_key]->value instanceof ArrayAccess)) {
-                        settype($this->tpl_vars[$_key]->value, 'array');
-                    }
-                    if ($merge && is_array($_val)) {
-                        foreach ($_val as $_mkey => $_mval) {
-                            $this->tpl_vars[$_key]->value[$_mkey] = $_mval;
-                        }
-                    } else {
-                        $this->tpl_vars[$_key]->value[] = $_val;
-                    }
-                }
-            }
-        } else {
-            if ($tpl_var != '' && isset($value)) {
-                if (!isset($this->tpl_vars[$tpl_var])) {
-                    $tpl_var_inst = $this->getVariable($tpl_var, null, true, false);
-                    if ($tpl_var_inst instanceof Undefined_Smarty_Variable) {
-                        $this->tpl_vars[$tpl_var] = new Smarty_variable(null, $nocache);
-                    } else {
-                        $this->tpl_vars[$tpl_var] = clone $tpl_var_inst;
-                    }
-                }
-                if (!(is_array($this->tpl_vars[$tpl_var]->value) || $this->tpl_vars[$tpl_var]->value instanceof ArrayAccess)) {
-                    settype($this->tpl_vars[$tpl_var]->value, 'array');
-                }
-                if ($merge && is_array($value)) {
-                    foreach ($value as $_mkey => $_mval) {
-                        $this->tpl_vars[$tpl_var]->value[$_mkey] = $_mval;
-                    }
-                } else {
-                    $this->tpl_vars[$tpl_var]->value[] = $value;
-                }
-            }
-        }
 
-        return $this;
-    }
-
     /**
      * appends values to template variables by reference
      *
@@ -178,399 +149,92 @@
      * @param  mixed   &$value  the referenced value to append
      * @param  boolean $merge   flag if array elements shall be merged
      *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
      */
     public function appendByRef($tpl_var, &$value, $merge = false)
     {
-        if ($tpl_var != '' && isset($value)) {
-            if (!isset($this->tpl_vars[$tpl_var])) {
-                $this->tpl_vars[$tpl_var] = new Smarty_variable();
+        return $this->ext->appendByRef->appendByRef($this, $tpl_var, $value, $merge);
-            }
+    }
-            if (!is_array($this->tpl_vars[$tpl_var]->value)) {
-                settype($this->tpl_vars[$tpl_var]->value, 'array');
-            }
-            if ($merge && is_array($value)) {
-                foreach ($value as $_key => $_val) {
-                    $this->tpl_vars[$tpl_var]->value[$_key] = & $value[$_key];
-                }
-            } else {
-                $this->tpl_vars[$tpl_var]->value[] = & $value;
-            }
-        }
 
-        return $this;
-    }
-
     /**
-     * Returns a single or all template variables
+     * assigns values to template variables by reference
      *
-     * @param  string  $varname        variable name or null
-     * @param  object   $_ptr           optional pointer to data object
-     * @param  boolean $search_parents include parent templates?
+     * @param string   $tpl_var the template variable name
+     * @param          $value
+     * @param  boolean $nocache if true any output of this variable will be not cached
      *
-     * @return string  variable value or or array of variables
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
      */
-    public function getTemplateVars($varname = null, $_ptr = null, $search_parents = true)
+    public function assignByRef($tpl_var, &$value, $nocache = false)
     {
-        if (isset($varname)) {
-            $_var = $this->getVariable($varname, $_ptr, $search_parents, false);
-            if (is_object($_var)) {
-                return $_var->value;
-            } else {
-                return null;
+        return $this->ext->assignByRef->assignByRef($this, $tpl_var, $value, $nocache);
-            }
+    }
-        } else {
-            $_result = array();
-            if ($_ptr === null) {
-                $_ptr = $this;
-            }
-            while ($_ptr !== null) {
-                foreach ($_ptr->tpl_vars AS $key => $var) {
-                    if (!array_key_exists($key, $_result)) {
-                        $_result[$key] = $var->value;
-                    }
-                }
-                // not found, try at parent
-                if ($search_parents) {
-                    $_ptr = $_ptr->parent;
-                } else {
-                    $_ptr = null;
-                }
-            }
-            if ($search_parents && isset(Smarty::$global_tpl_vars)) {
-                foreach (Smarty::$global_tpl_vars AS $key => $var) {
-                    if (!array_key_exists($key, $_result)) {
-                        $_result[$key] = $var->value;
-                    }
-                }
-            }
 
-            return $_result;
-        }
-    }
-
     /**
-     * clear the given assigned template variable.
+     * Returns a single or all template variables
      *
-     * @param  string|array $tpl_var the template variable(s) to clear
+     * @api  Smarty::getTemplateVars()
+     * @link http://www.smarty.net/docs/en/api.get.template.vars.tpl
      *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function clearAssign($tpl_var)
-    {
-        if (is_array($tpl_var)) {
-            foreach ($tpl_var as $curr_var) {
-                unset($this->tpl_vars[$curr_var]);
-            }
-        } else {
-            unset($this->tpl_vars[$tpl_var]);
-        }
-
-        return $this;
-    }
-
-    /**
-     * clear all the assigned template variables.
+     * @param  string                                                 $varName       variable name or null
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $_ptr          optional pointer to data object
+     * @param  bool                                                   $searchParents include parent templates?
      *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @return mixed variable value or or array of variables
      */
-    public function clearAllAssign()
+    public function getTemplateVars($varName = null, Smarty_Internal_Data $_ptr = null, $searchParents = true)
     {
-        $this->tpl_vars = array();
-
-        return $this;
+        return $this->ext->getTemplateVars->getTemplateVars($this, $varName, $_ptr, $searchParents);
     }
 
     /**
-     * load a config file, optionally load just selected sections
-     *
-     * @param  string $config_file filename
-     * @param  mixed  $sections    array of section names, single section or null
-     *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function configLoad($config_file, $sections = null)
-    {
-        // load Config class
-        $config = new Smarty_Internal_Config($config_file, $this->smarty, $this);
-        $config->loadConfigVars($sections);
-
-        return $this;
-    }
-
-    /**
      * gets the object of a Smarty variable
      *
      * @param  string  $variable       the name of the Smarty variable
-     * @param  object  $_ptr           optional pointer to data object
-     * @param  boolean $search_parents search also in parent data
+     * @param  Smarty_Internal_Data  $_ptr           optional pointer to data object
+     * @param  boolean $searchParents search also in parent data
      * @param bool     $error_enable
      *
-     * @return object  the object of the variable
+     * @return Smarty_Variable|Smarty_Undefined_Variable the object of the variable
+     * @deprecated since 3.1.28 please use Smarty_Internal_Data::getTemplateVars() instead.
      */
-    public function getVariable($variable, $_ptr = null, $search_parents = true, $error_enable = true)
-    {
-        if ($_ptr === null) {
-            $_ptr = $this;
+    public function getVariable($variable = null, Smarty_Internal_Data $_ptr = null, $searchParents = true, $error_enable = true){
+        return $this->ext->getTemplateVars->_getVariable($this, $variable, $_ptr, $searchParents, $error_enable);
-        }
+    }
-        while ($_ptr !== null) {
-            if (isset($_ptr->tpl_vars[$variable])) {
-                // found it, return it
-                return $_ptr->tpl_vars[$variable];
-            }
-            // not found, try at parent
-            if ($search_parents) {
-                $_ptr = $_ptr->parent;
-            } else {
-                $_ptr = null;
-            }
-        }
-        if (isset(Smarty::$global_tpl_vars[$variable])) {
-            // found it, return it
-            return Smarty::$global_tpl_vars[$variable];
-        }
-        if ($this->smarty->error_unassigned && $error_enable) {
-            // force a notice
-            $x = $$variable;
-        }
-
+    
-        return new Undefined_Smarty_Variable;
-    }
-
     /**
-     * gets  a config variable
+     * Follow the parent chain an merge template and config variables
      *
-     * @param  string $variable the name of the config variable
-     * @param bool    $error_enable
-     *
-     * @return mixed  the value of the config variable
+     * @param \Smarty_Internal_Data|null $data
      */
-    public function getConfigVariable($variable, $error_enable = true)
+    public function _mergeVars(Smarty_Internal_Data $data = null)
     {
-        $_ptr = $this;
-        while ($_ptr !== null) {
-            if (isset($_ptr->config_vars[$variable])) {
-                // found it, return it
-                return $_ptr->config_vars[$variable];
+        if (isset($data)) {
+            if (!empty($this->tpl_vars)) {
+                $data->tpl_vars = array_merge($this->tpl_vars, $data->tpl_vars);
             }
-            // not found, try at parent
-            $_ptr = $_ptr->parent;
+            if (!empty($this->config_vars)) {
+                $data->config_vars = array_merge($this->config_vars, $data->config_vars);
-        }
+            }
-        if ($this->smarty->error_unassigned && $error_enable) {
-            // force a notice
-            $x = $$variable;
-        }
-
-        return null;
-    }
-
-    /**
-     * gets  a stream variable
-     *
-     * @param  string $variable the stream of the variable
-     *
-     * @throws SmartyException
-     * @return mixed  the value of the stream variable
-     */
-    public function getStreamVariable($variable)
-    {
-        $_result = '';
-        $fp = fopen($variable, 'r+');
-        if ($fp) {
-            while (!feof($fp) && ($current_line = fgets($fp)) !== false) {
-                $_result .= $current_line;
-            }
-            fclose($fp);
-
-            return $_result;
-        }
-
-        if ($this->smarty->error_unassigned) {
-            throw new SmartyException('Undefined stream variable "' . $variable . '"');
         } else {
-            return null;
+            $data = $this;
         }
+        if (isset($this->parent)) {
+            $this->parent->_mergeVars($data);
-    }
+        }
-
-    /**
-     * Returns a single or all config variables
-     *
-     * @param  string $varname variable name or null
-     * @param bool    $search_parents
-     *
-     * @return string variable value or or array of variables
-     */
-    public function getConfigVars($varname = null, $search_parents = true)
-    {
-        $_ptr = $this;
-        $var_array = array();
-        while ($_ptr !== null) {
-            if (isset($varname)) {
-                if (isset($_ptr->config_vars[$varname])) {
-                    return $_ptr->config_vars[$varname];
-                }
+    }
-            } else {
-                $var_array = array_merge($_ptr->config_vars, $var_array);
-            }
-            // not found, try at parent
-            if ($search_parents) {
-                $_ptr = $_ptr->parent;
-            } else {
-                $_ptr = null;
-            }
-        }
-        if (isset($varname)) {
-            return '';
-        } else {
-            return $var_array;
-        }
-    }
 
     /**
-     * Deassigns a single or all config variables
+     * Handle unknown class methods
      *
-     * @param  string $varname variable name or null
+     * @param string $name unknown method-name
+     * @param array  $args argument array
      *
-     * @return Smarty_Internal_Data current Smarty_Internal_Data (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function clearConfig($varname = null)
-    {
-        if (isset($varname)) {
-            unset($this->config_vars[$varname]);
-        } else {
-            $this->config_vars = array();
-        }
-
-        return $this;
-    }
-}
-
-/**
- * class for the Smarty data object
- * The Smarty data object will hold Smarty variables in the current scope
- *
- * @package    Smarty
- * @subpackage Template
- */
-class Smarty_Data extends Smarty_Internal_Data
-{
-    /**
-     * Smarty object
-     *
-     * @var Smarty
-     */
-    public $smarty = null;
-
-    /**
-     * create Smarty data object
-     *
-     * @param Smarty|array $_parent parent template
-     * @param Smarty|Smarty_Internal_Template       $smarty  global smarty instance
-     *
+     * @return mixed
      * @throws SmartyException
      */
-    public function __construct($_parent = null, $smarty = null)
+    public function __call($name, $args)
     {
-        $this->smarty = $smarty;
-        if (is_object($_parent)) {
-            // when object set up back pointer
-            $this->parent = $_parent;
-        } elseif (is_array($_parent)) {
-            // set up variable values
-            foreach ($_parent as $_key => $_val) {
-                $this->tpl_vars[$_key] = new Smarty_variable($_val);
-            }
-        } elseif ($_parent != null) {
-            throw new SmartyException("Wrong type for template variables");
-        }
-    }
-}
-
-/**
- * class for the Smarty variable object
- * This class defines the Smarty variable object
- *
- * @package    Smarty
- * @subpackage Template
- */
-class Smarty_Variable
-{
-    /**
-     * template variable
-     *
-     * @var mixed
-     */
-    public $value = null;
-    /**
-     * if true any output of this variable will be not cached
-     *
-     * @var boolean
-     */
-    public $nocache = false;
-    /**
-     * the scope the variable will have  (local,parent or root)
-     *
-     * @var int
-     */
-    public $scope = Smarty::SCOPE_LOCAL;
-
-    /**
-     * create Smarty variable object
-     *
-     * @param mixed   $value   the value to assign
-     * @param boolean $nocache if true any output of this variable will be not cached
-     * @param int     $scope   the scope the variable will have  (local,parent or root)
-     */
-    public function __construct($value = null, $nocache = false, $scope = Smarty::SCOPE_LOCAL)
-    {
-        $this->value = $value;
-        $this->nocache = $nocache;
-        $this->scope = $scope;
-    }
-
-    /**
-     * <<magic>> String conversion
-     *
-     * @return string
-     */
-    public function __toString()
-    {
-        return (string) $this->value;
-    }
-}
-
-/**
- * class for undefined variable object
- * This class defines an object for undefined variable handling
- *
- * @package    Smarty
- * @subpackage Template
- */
-class Undefined_Smarty_Variable
-{
-    /**
-     * Returns FALSE for 'nocache' and NULL otherwise.
-     *
-     * @param  string $name
-     *
-     * @return bool
-     */
-    public function __get($name)
-    {
-        if ($name == 'nocache') {
-            return false;
-        } else {
-            return null;
-        }
-    }
-
-    /**
-     * Always returns an empty string.
-     *
-     * @return string
-     */
-    public function __toString()
-    {
-        return "";
+        return $this->ext->_callExternalMethod($this, $name, $args);
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_setfilter.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_setfilter.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_setfilter.php	(revision )
@@ -25,10 +25,10 @@
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
-        $compiler->variable_filter_stack[] = $compiler->template->variable_filters;
-        $compiler->template->variable_filters = $parameter['modifier_list'];
+        $compiler->variable_filter_stack[] = $compiler->variable_filters;
+        $compiler->variable_filters = $parameter['modifier_list'];
         // this tag does not return compiled code
         $compiler->has_code = false;
 
@@ -53,14 +53,14 @@
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         $_attr = $this->getAttributes($compiler, $args);
         // reset variable filter to previous state
         if (count($compiler->variable_filter_stack)) {
-            $compiler->template->variable_filters = array_pop($compiler->variable_filter_stack);
+            $compiler->variable_filters = array_pop($compiler->variable_filter_stack);
         } else {
-            $compiler->template->variable_filters = array();
+            $compiler->variable_filters = array();
         }
         // this tag does not return compiled code
         $compiler->has_code = false;
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterplugin.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterplugin.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterplugin.php	(revision )
@@ -0,0 +1,41 @@
+<?php
+
+/**
+ * Smarty Method UnregisterPlugin
+ *
+ * Smarty::unregisterPlugin() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_UnregisterPlugin
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers plugin to be used in templates
+     *
+     * @api  Smarty::unregisterPlugin()
+     * @link http://www.smarty.net/docs/en/api.unregister.plugin.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $type       plugin type
+     * @param  string                                                         $name       name of template tag
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+      */
+    public function unregisterPlugin(Smarty_Internal_TemplateBase $obj, $type, $name)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (isset($smarty->registered_plugins[$type][$name])) {
+            unset($smarty->registered_plugins[$type][$name]);
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_cachemodify.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_cachemodify.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_cachemodify.php	(revision )
@@ -0,0 +1,67 @@
+<?php
+
+/**
+ * Inline Runtime Methods render, setSourceByUid, setupSubTemplate
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_CacheModify
+{
+    /**
+     * check client side cache
+     *
+     * @param Smarty_Internal_Template $_template
+     * @param  string                  $content
+     */
+    public function cacheModifiedCheck(Smarty_Template_Cached $cached, Smarty_Internal_Template $_template, $content)
+    {
+        $_isCached = $_template->isCached() && !$_template->compiled->has_nocache_code;
+        $_last_modified_date =
+            @substr($_SERVER['HTTP_IF_MODIFIED_SINCE'], 0, strpos($_SERVER['HTTP_IF_MODIFIED_SINCE'], 'GMT') + 3);
+        if ($_isCached && $cached->timestamp <= strtotime($_last_modified_date)) {
+            switch (PHP_SAPI) {
+                case 'cgi': // php-cgi < 5.3
+                case 'cgi-fcgi': // php-cgi >= 5.3
+                case 'fpm-fcgi': // php-fpm >= 5.3.3
+                    header('Status: 304 Not Modified');
+                    break;
+
+                case 'cli':
+                    if ( /* ^phpunit */
+                    !empty($_SERVER['SMARTY_PHPUNIT_DISABLE_HEADERS']) /* phpunit$ */
+                    ) {
+                        $_SERVER['SMARTY_PHPUNIT_HEADERS'][] = '304 Not Modified';
+                    }
+                    break;
+
+                default:
+                    if ( /* ^phpunit */
+                    !empty($_SERVER['SMARTY_PHPUNIT_DISABLE_HEADERS']) /* phpunit$ */
+                    ) {
+                        $_SERVER['SMARTY_PHPUNIT_HEADERS'][] = '304 Not Modified';
+                    } else {
+                        header($_SERVER['SERVER_PROTOCOL'] . ' 304 Not Modified');
+                    }
+                    break;
+            }
+        } else {
+            switch (PHP_SAPI) {
+                case 'cli':
+                    if ( /* ^phpunit */
+                    !empty($_SERVER['SMARTY_PHPUNIT_DISABLE_HEADERS']) /* phpunit$ */
+                    ) {
+                        $_SERVER['SMARTY_PHPUNIT_HEADERS'][] =
+                            'Last-Modified: ' . gmdate('D, d M Y H:i:s', $cached->timestamp) . ' GMT';
+                    }
+                    break;
+                default:
+                    header('Last-Modified: ' . gmdate('D, d M Y H:i:s', $cached->timestamp) . ' GMT');
+                    break;
+            }
+            echo $content;
+        }
+    }
+}
